<?php

/**
 * co_seleccion_etapa actions.
 *
 * @package    contratacion
 * @subpackage co_seleccion_etapa
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class co_seleccion_etapaActions extends sfQuery
{
    /*
    * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
    */
    protected $table_names = array(
        'CO_SELECCION_ETAPA','CO_SELECCION_EP','CO_ESTUDIOS_PREVIOS', 'CO_ETAPA_MODALIDAD', 'CO_ETAPA','CO_MODALIDAD_SEL'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CO_SELECCION_EP' =>
         array (
            'id_seleccion_ep' => 'CO_SELECCION_ETAPA'
         ),        
        'CO_ESTUDIOS_PREVIOS' =>
         array (
            'id_estudios_previos' => 'CO_SELECCION_EP'
         ),
        'CO_ETAPA_MODALIDAD' =>
        array(
            'id_etapa_modalidad' => 'CO_SELECCION_ETAPA'
        ),
        'CO_ETAPA' => 
        array(
            'id_etapa' => 'CO_ETAPA_MODALIDAD'
        ),
        'CO_MODALIDAD_SEL' =>
        array(
            'id_modalidad_sel' => 'CO_ESTUDIOS_PREVIOS'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
       'CO_SELECCION_ETAPA' =>
       array(
            'id_seleccion_etapa' => 'id_seleccion_etapa',
            'id_seleccion_ep' => 'id_seleccion_ep',
            'id_etapa_modalidad' => 'id_etapa_modalidad',
            'fecha' => 'fecha',
            'numero' => 'numero',
            'num_oferentes' => 'num_oferentes',
            'num_adjudicatarios' => 'num_adjudicatarios',
            'fecha_desde' => 'fecha_desde',
            'fecha_hasta' => 'fecha_hasta',
            'observaciones' => 'observaciones',
            'adjunto' => 'adjunto'
           
        ),
        'CO_SELECCION_EP' =>
        array(
            'fecha_inicio' => 'fecha_inicio',
            'estado' => 'estado'
        ),
        'CO_ESTUDIOS_PREVIOS'=>
        array(
            'no_proceso' => 'no_proceso',
            'id_anhos' => 'id_anhos',
            'fecha_creacion' => 'fecha_creacion'
        ),
        'CO_ETAPA_MODALIDAD'=>
        array(
            'id_modalidad_sel' => 'id_modalidad_sel',
            'id_etapa' => 'id_etapa',
            'orden' => 'orden'
        ),
        'CO_MODALIDAD_SEL'=>
        array(
          'descripcion' => 'descripcion_modalidad'  
        ),
        'CO_ETAPA' =>
        array(
            'descripcion' => 'descripcion_etapa',
            'aplica_tiempo' => 'aplica_tiempo',
            'aplica_numero' => 'aplica_numero',
            'aplica_desde_hasta' => 'aplica_desde_hasta',
            'aplica_oferentes' => 'aplica_oferentes',
            'aplica_adjudicatario' => 'aplica_adjudicatario'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
        'orden'
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
       'CO_SELECCION_ETAPA' =>
        array(    
            'id_seleccion_etapa,a' => array('!=' => array(-1)),
            'id_seleccion_etapa,b' => array('=' => array('id_seleccion_etapa')),
            'id_seleccion_ep,b' => array('=' => array('id_seleccion_ep')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        ),
        'CO_SELECCION_EP' =>
        array(
            'id_estudios_previos' => array('=' => array('id_estudios_previos')),
        )
        
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_seleccion_etapa'; //identificador de la tabla
    protected $id_names = array('id_seleccion_etapa'); //llave primaria
    protected $field_names = array('id_seleccion_ep','id_etapa_modalidad','fecha','numero','num_oferentes','num_adjudicatarios','fecha_desde','fecha_hasta','observaciones','adjunto'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CO_SELECCION_ETAPA'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_seleccion_etapa'; //identificador unico de la tabla
    
    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
         /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, sfWebRequest $request) {
         /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest"); 
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
             $logger->info("Entro a ADD"); 
             
            $id_etapa_modalidad = $request['id_etapa_modalidad'];
            
            $sql = <<<EOD
            SELECT tab1.*
                from co_etapa_modalidad tab0
                join co_etapa tab1 ON tab1.id_etapa = tab0.id_etapa
                where tab0.id_etapa_modalidad = $id_etapa_modalidad

EOD;

            $results = CN_TABLE::executeSQL($sql);

            
            $aplica_desde_hasta = $results[0]['aplica_desde_hasta'];
            if($aplica_desde_hasta==0){
                $request['fecha_desde'] = null;
                $request['fecha_hasta'] = null;
                
            }
            
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(sfWebRequest $request) {
         //valor por defecto
        $errors = null;

        $id_etapa_modalidad = $request['id_etapa_modalidad'];
        $id_seleccion_ep = $request['id_seleccion_ep'];
        
        
        
        /*
         *  Validar la operación, ya sea por SQL
         */
        $sql = <<<EOD
            SELECT tab0.*
                from co_seleccion_etapa tab0
                where tab0.id_etapa_modalidad = $id_etapa_modalidad and tab0.id_seleccion_ep = $id_seleccion_ep

EOD;

            $results = CN_TABLE::executeSQL($sql);
        
            if(count($results)>0){
                 $errors['mensaje'] = "Ya ha registrado esta Etapa";
                 $errors['servicio'] = "co_seleccion_etapa";
            }

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
         //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
         //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }    
}
